##############################################

Programmierpraktikum: Datensysteme SOSE 24

##############################################

Goal:
------------------
- Create your own query processing engine
- Implement the CompilePlan method
- Implement the physical operators, which inherit from the ONCIterator in types.h

Test your implementation:
------------------
- In order to pass this course the `basic_test` and `benchmark` executables have to pass.
- Write additional unit tests where you also test some special use cases
- Generate the data for `benchmark`:
````
$ mkdir -p data/benchmark
$ git clone https://github.com/eyalroz/ssb-dbgen.git
$ cd ssb-dbgen
$ cmake . && cmake --build .
$ ./dbgen -v -s 1
$ mv *.tbl ../data/benchmark
````

- Build and run the executables with `cmake` in release mode for benchmarking:
````
$ mkdir -p build
$ cd build
$ cmake .. -DCMAKE_BUILD_TYPE=Release
$ make
$ cd ..
$ ./build/benchmark
````

- The minimum performance target for your implementation is: T(SUT) < T(ref_impl) / 4
- Build and run the reference implementation in ppds-reference-cpp according to the steps above for comparison


System specifications:
-----------------
We will test your implementation on our scale-up box:
- CPU: Intel(R) Xeon(R) Gold 6338 CPU @ 2.00GHz
- Cores: 128
- RAM: 1008GB
- OS: Ubuntu 20.04
- C/C++ Compiler: gcc/g++ 11
- Java-11: Openjdk 11.0.20
